function [initParams A B skalering] = initParams();
c_p_b = 800;    %betong
c_p_s = 460;    %stl
c_p_l = 1012;   %luft
c_p_v = 4018;   %vann

rho = 1.2041;   %tetthet luft
rhob = 

omega_r   = 0.5;
omega_g = 1;

s = 0.26;   %solfaktor

P_el = 30000;

%Data 1.etg og 2.etg
A1  = 600;
h1  = 3;
hg = 0.1;
A_12 = 600;    %areal mellom 1. og 2.
A_1h = 45;     %arela mellom 1. og hall
A_1g = A1;    %areal mellom 1. og gulv
U_12 = 0.5;    %U-verdi mellom 1. og 2.
U_1h = 0.5;    %U-verdi mellom 1. og hall
U_1g = 10;     %U-verdi mellom 1. og gulv (basert p luft/betong)
U_1r = 7.9;    %varmeovergang stl-luft [WK/m^2]


%forstyrrelser 1.etg og 2.etg
A_1yv = 140;    %areal yttervegger
A_1v = 150;    %areal vinduer
A_1r = 32;     %Arealradiatorer
U_1yv = 0.22;   %U-verdi yttervegg
U_1v = 1.4;    %U-verdi vinduer


%Data 3.etg
A3 = 500;
A_23 = A3;
A_3r = 40;
U_3t = 0.15;
%forstyrrelser 3.etg


%Data hall
Ah = 300;
hh = 6;

%forstyrrelser hall
A_hyv = 72;
A_hv = 260;



%A-matrise rad 1
K_12 = A_12*U_12;
K_1h = A_1h*U_1h;
K_1g = A_1g*U_1g;
K_1r = A_1r*U_1r;
K_1u = A_1yv*U_1yv + A_1v*U_1v;
K_23 = A_23*U_12;
K_2h = K_1h;
K_2r = K_1r;
K_2u = K_1u;
K_3h = K_1h;
K_3r = A_3r*U_1r;
K_3u = K_1u+A3*U_3t;
K_hg = Ah*U_1g;
K_hu = A_hyv*U_1yv+Ah*U_3t+A_hv*U_1v;
K_hr = 0;
K_1l = 0.5;
K_2l = K_1l;
K_3l = K_1l;
K_hl = K_1l;
K_1p = 2000;
K_2p = K_1p;
K_3p = K_1p;

%B-matrise
K_gv  = c_p_v*omega_g;
K_rv  = c_p_v*omega_r;
K_1s  = A_1v*s;
K_2s  = K_1s;
K_3s  = K_1s;
K_hs  = A_hv*s;
P_1el = 0.3;
P_2el = P_1el;
P_3el = 0.25;
P_hel = 0.15;
P_gkonst = 0;
P_rkonst = 0;

%Skalering
m1 = A1*h1*rho;
m2 = m1;
m3 = A3*h1*rho;
mh = Ah*hh*rho;
mg = (A1+Ah)*hg*rhob;
mr = (2*A_1r+A_3r)*20;


K_11 = K_12+K_1h+K_1g+K_1r      +K_1u+K_1l;
K_22 = K_12+K_23+K_2h+K_2r      +K_2u+K_2l;
K_33 = K_23+K_3h+K_3r           +K_3u+K_3l;
K_hh = K_1h+K_2h+K_3h+K_hg+K_hr +K_3u+K_hl;
K_gg = K_hg+K_1g                +K_gv;
K_rr = K_1r+K_2r+K_3r+K_hr      +K_rv;



initParams = [K_12, K_1h, K_1g, K_1r, K_1u, K_23, K_2h, K_2r, K_2u, K_3h, K_3r, K_3u, K_hg, K_hr, K_hu, K_1l, K_2l, K_3l, K_hl, K_gv, K_rv, K_1s, K_2s, K_3s, K_hs, P_1el, P_2el, P_3el, P_hel, P_gkonst, P_rkonst, m1, m2, m3, mh, mg, mr, K_1p, K_2p, K_3p]';


