clear all;
% 
c_pc = 800;
c_ps = 460;
c_pl = 1020;
rho = 1.2041;


load modeller;
load data

m=me4;


p=zeros(40,1);
for i = 1:40
p(i) = m.parameters(i).Value;
end

K_12 = p(1);
K_1h = p(2);
K_1g = p(3);
K_1r = p(4);
K_1u = p(5);
K_23 = p(6);
K_2h = p(7);
K_2r = p(8);
K_2u = p(9);
K_3h = p(10);
K_3r = p(11);
K_3u = p(12);
K_hg = p(13);
K_hr = p(14);
K_hu = p(15);
K_1l = p(16);
K_2l = p(17);
K_3l = p(18);
K_hl = p(19);
K_gv = p(20);
K_rv = p(21);
K_1s = p(22);
K_2s = p(23);
K_3s = p(24);
K_hs = p(25);
P_1el = p(26);
P_2el = p(27);
P_3el   = p(28);
P_hel   = p(29);
P_gkonst= p(30);
P_rkonst= p(31);
m1      = p(32);
m2      = p(33);
m3      = p(34);
mh      = p(35);
mg      = p(36);
mr      = p(37);
K_1p    = p(38);
K_2p    = p(39);
K_3p    = p(40);

p2 = [K_12, K_1h, K_1g, K_1r, K_1u, K_23, K_2h, K_2r, K_2u, K_3h, K_3r, K_3u, K_hg, K_hr, K_hu, K_1l, K_2l, K_3l, K_hl, K_gv, K_rv, K_1s, K_2s, K_3s, K_hs, P_1el, P_2el, P_3el, P_hel, P_gkonst, P_rkonst, m1, m2, m3, mh, mg, mr, K_1p, K_2p, K_3p]';

K_23 = K_12*K_23;
K_2h = K_1h*K_2h;
K_3h = K_1h*K_3h;
K_2r = K_1r*K_2r;
K_3r = K_1r*K_3r;
K_hg = K_1g*K_hg;
K_2s = K_1s*K_2s;
K_3s = K_1s*K_3s;

OC_p1a  = 2250*c_pl*rho/3600;
OC_p2a  = 2250*c_pl*rho/3600;

OC_p1b = 8000*c_pl*rho/3600;
OC_p2b = 9500*c_pl*rho/3600;


K_11 = K_12+K_1h+K_1g+K_1r      +K_1u+K_1l*OC_p1a;
K_22 = K_12+K_23+K_2h+K_2r      +K_2u+K_2l*OC_p1a;
K_33 = K_23+K_3h+K_3r           +K_3u+K_3l*OC_p2a;
K_hh = K_1h+K_2h+K_3h+K_hg+K_hr +K_3u+K_hl*OC_p2a;
K_gg = K_hg+K_1g                +K_gv;
K_rr = K_1r+K_2r+K_3r+K_hr      +K_rv;

Aa = [
    -K_11 K_12  0     K_1h  K_1g    K_1r;   %1.etg
    K_12  -K_22 K_23  K_2h  0       K_2r;   %2.etg
    0     K_23  -K_33 K_3h  0       K_3r;   %3.etg
    K_1h  K_2h  K_3h  -K_hh K_hg    K_hr;   %hall
    K_1g  0     0     K_hg  -K_gg   0;      %gulv
    K_1r  K_2r  K_3r  K_hr     0    -K_rr   %radiatorer
    ];
K_11 = K_12+K_1h+K_1g+K_1r      +K_1u+K_1l*OC_p1b;
K_22 = K_12+K_23+K_2h+K_2r      +K_2u+K_2l*OC_p1b;
K_33 = K_23+K_3h+K_3r           +K_3u+K_3l*OC_p2b;
K_hh = K_1h+K_2h+K_3h+K_hg+K_hr +K_3u+K_hl*OC_p2b;
Ab = [
    -K_11 K_12  0     K_1h  K_1g    K_1r;   %1.etg
    K_12  -K_22 K_23  K_2h  0       K_2r;   %2.etg
    0     K_23  -K_33 K_3h  0       K_3r;   %3.etg
    K_1h  K_2h  K_3h  -K_hh K_hg    K_hr;   %hall
    K_1g  0     0     K_hg  -K_gg   0;      %gulv
    K_1r  K_2r  K_3r  K_hr     0    -K_rr   %radiatorer
    ];


Ba = [
    K_1l*OC_p1a 0           0     0    K_1u  K_1s P_1el    K_1p;
    K_2l*OC_p1a 0           0     0    K_2u  K_2s P_2el    K_1p;
    0           K_3l*OC_p2a 0     0    K_3u  K_3s P_3el    K_3p;
    0           K_hl*OC_p2a 0     0    K_hu  K_hs P_hel    0;
    0           0           K_gv  0    0     0    P_gkonst 0;
    0           0           0     K_rv 0     0    P_rkonst 0
    ];

Bb = [
    K_1l*OC_p1b 0           0     0    K_1u  K_1s P_1el    K_1p;
    K_2l*OC_p1b 0           0     0    K_2u  K_2s P_2el    K_1p;
    0           K_3l*OC_p2b 0     0    K_3u  K_3s P_3el    K_3p;
    0           K_hl*OC_p2b 0     0    K_hu  K_hs P_hel    0;
    0           0           K_gv  0    0     0    P_gkonst 0;
    0           0           0     K_rv 0     0    P_rkonst 0
    ];

C = [
    1 0 0 0 0 0;
    0 1 0 0 0 0;
    0 0 1 0 0 0;
    0 0 0 1 0 0;
    ];

C2 = [
    1 0 0 0 0 0;
    0 1 0 0 0 0;
    0 0 1 0 0 0;
    0 0 0 1 0 0;
    0 0 0 0 1 0;
    ];

D = zeros(4,8);

K = zeros(6,4);

skalering = (30)*diag([1/m1/c_pl 1/m2/c_pl 1/m3/c_pl 1/mh/c_pl 1/mg/c_pc 1/mr/c_ps]);
Aa = skalering * Aa;
Ab = skalering * Ab;
Ba = skalering*Ba;
Bb = skalering*Bb;

%kalman
q = ones(1,8);
q(1) = 10^2; %Ventilasjon2
q(2) = 10^2; %Ventilasjon3
q(3) = 2^2; %Gulv tur temp
q(4) = 2^2; %Radiator tur temp
q(5)= 5^2;  %utetemp
q(6)= 100^2;  %solinnstrling
q(7)= 1^2;  %konstant/el
q(8)= 0.5^2;  %personer

Q = diag(q);


r(1) = std(zhp.y(:,1))^2;
r(2) = std(zhp.y(:,2))^2;
r(3) = std(zhp.y(:,3))^2;
r(4) = std(zhp.y(:,4))^2;
R = diag(r);


SSa = ss(Aa,Ba,C,0);
SSb = ss(Ab,Bb,C,0);
SSa2 = ss(Aa,Ba(:,1:3),C,0);

SSda= c2d(SSa,1);
SSdb= c2d(SSb,1);

kalmanSSa= ss(SSda.a, [SSda.b SSda.b], SSda.c,0,1);
kalmanSSb= ss(SSdb.a, [SSdb.b SSdb.b], SSdb.c,0,1);


[kesta La Pa Ma] = kalman(kalmanSSa,Q,R,'current');
[kestb Lb Pb Mb] = kalman(kalmanSSb,Q,R,'current');


%lqr
SSlqra =c2d(ss(Aa,Ba(:,1:3),C,0),1);
SSlqrb =c2d(ss(Ab,Bb(:,1:3),C,0),1);
Qlqr = 100*diag([1 1 1 1 1 0]);
Qlqri = diag([1 1 1 1]);
Rlqr = diag([1 1 1]);
Nlqr = ones(10,3);

igain = 0.1*diag([1 1 1]);

[Ka,Sa,ea] = dlqr(SSlqra.a,SSlqra.b,Qlqr,Rlqr)
[Kb,Sb,eb] = dlqr(SSlqrb.a,SSlqrb.b,Qlqr,Rlqr)
kmst = 20159;






%Sty
noisew.time = 1:kmst;
noisew.signals.values(:,1) = 0.2*rand(kmst,1);
noisew.signals.values(:,2) = 0.2*rand(kmst,1);
noisew.signals.values(:,3) = 0.01*rand(kmst,1);
noisew.signals.values(:,4) = 0.3*rand(kmst,1);


starttemp = zeros(6,1);
for i = 1:6
    starttemp(i) = m.Initialstates(i).Value;
end
starttemp = [19.2 21.6 21.1 19.4 20.1 45];



%Foroverkobling
ffeamp = 0;
fferror = diag(ffeamp/2*[1 1 1 1 1]+[1 1 1 1 1]-ffeamp*rand(1,5));
BaVec = [Ba(1,1) Ba(2,1) Ba(3,2) Ba(4,2) Ba(5,3)]';
BbVec = [Bb(1,1) Bb(2,1) Bb(3,2) Bb(4,2) Bb(5,3)]';

sim kalman
sim kalmanlqr
sim ff




